//	Darkstar Engine  (c) UnderWorld Interactive Studio (all coding by Svarog    2007-2008)
//
//          Darkstar Engine.    
//        ,       ( -
//          ).
//
//       : constant_table_d3d10.cpp
//       : Constant table for effect for directx 10 platform
//

#ifdef GD_D3D10

#include <Darkstar/Graphic System/Effect/constant_table.hpp>
#include <Darkstar/Graphic System/Direct3D/graphicDriver.hpp>

using gs::GraphicDriver;
using gs::Constant;
using gs::ConstantTable;
using gs::CONSTANT_TYPE;
using gs::PS_CONST;
using gs::VS_CONST;

bool ConstantTable::setBoolArray(const std::string& name, const bool* values, unsigned int count)
{
	std::pair<storage::iterator, storage::iterator> it_range = constants.equal_range(name);
	storage::iterator it;
	if(it_range.second == it_range.first)
		return false;
	for(it = it_range.first; it != it_range.second; ++it)
	{
		Constant con = it->second;
		if(con.type == VS_CONST)
			GraphicDriver::ptr()->getVSConstantBuffer()->setConstantsArray(con.register_index, count, (char*)values);
		else
			GraphicDriver::ptr()->getPSConstantBuffer()->setConstantsArray(con.register_index, count, (char*)values);
	};
	return true;
};

bool ConstantTable::setFloatArray(const std::string& name, const float* values, unsigned int count)
{
	std::pair<storage::iterator, storage::iterator> it_range = constants.equal_range(name);
	storage::iterator it;
	if(it_range.second == it_range.first)
		return false;
	for(it = it_range.first; it != it_range.second; ++it)
	{
		Constant con = it->second;
		if(con.type == VS_CONST)
			GraphicDriver::ptr()->getVSConstantBuffer()->setConstantsArray(con.register_index, count*4, (char*)values);
		else
			GraphicDriver::ptr()->getPSConstantBuffer()->setConstantsArray(con.register_index, count*4, (char*)values);
	};
	return true;
};

bool ConstantTable::setIntArray(const std::string& name, const int* values, unsigned int count)
{
	std::pair<storage::iterator, storage::iterator> it_range = constants.equal_range(name);
	storage::iterator it;
	if(it_range.second == it_range.first)
		return false;
	for(it = it_range.first; it != it_range.second; ++it)
	{
		Constant con = it->second;
		if(con.type == VS_CONST)
			GraphicDriver::ptr()->getVSConstantBuffer()->setConstantsArray(con.register_index, count*4, (char*)values);
		else
			GraphicDriver::ptr()->getPSConstantBuffer()->setConstantsArray(con.register_index, count*4, (char*)values);
	};
	return true;
};

#endif

