//	Darkstar Engine  (c) UnderWorld Interactive Studio (all coding by Svarog    2007-2008)
//
//          Darkstar Engine.    
//        ,       ( -
//          ).
//
//       : pixel_shader_d3d10.cpp
//       :     DirectX 10
//

#ifdef GD_D3D10

#include <Darkstar/Graphic System/Effect/pixel_shader_d3d10.hpp>
#include <Darkstar/Graphic System/Direct3D/graphicDriver.hpp>
#include <Darkstar/Kernel/logh.hpp>

using gs::PixelShader;
using gs::GraphicDriver;
using ker::Log;

PixelShader::PixelShader()
{
	ps = NULL;
};

PixelShader::~PixelShader()
{
	if(ps)
	{
		ps->Release();
		ps = NULL;
	};
};

bool PixelShader::create(const void* code, const unsigned int code_size)
{
	if(FAILED(GraphicDriver::ptr()->getDevice()->CreatePixelShader(code, code_size, &ps)))
	{
		lwar << "Cannot create pixel shader";
		return false;
	};
	return true;
};

void PixelShader::set()
{
	GraphicDriver::ptr()->getDevice()->PSSetShader(ps);
};

#endif