//	Darkstar Engine  (c) UnderWorld Interactive Studio (all coding by Svarog    2007-2008)
//
//          Darkstar Engine.    
//        ,       ( -
//          ).
//
//       : pixel_shader_d3d9.cpp
//       :     DirectX 9
//

#ifdef GD_D3D9

#include <Darkstar/Graphic System/Effect/pixel_shader_d3d9.hpp>
#include <Darkstar/Graphic System/Direct3D/graphicDriver.hpp>
#include <Darkstar/Kernel/logh.hpp>

using gs::PixelShader;
using gs::GraphicDriver;
using ker::Log;

PixelShader::PixelShader()
{
	pshader = NULL;
};

PixelShader::~PixelShader()
{
	if(pshader)
	{
		pshader->Release();
		pshader = NULL;
	};
};

bool PixelShader::create(const void* code, const unsigned int code_size)
{
	if(FAILED(GraphicDriver::ptr()->getDevice()->CreatePixelShader((DWORD*)code, &pshader)))
	{
		lwar << "Cannot create pixel shader";
		return false;
	};
	return true;
};

void PixelShader::set()
{
	GraphicDriver::ptr()->getDevice()->SetPixelShader(pshader);
};

#endif