//	Darkstar Engine  (c) UnderWorld Interactive Studio (all coding by Svarog    2007)
//
//          Darkstar Engine.    
//        ,       ( -
//          ).
//
//       : shader_compiler_d3d10.cpp
//       : shader compiler for directx 10
//

#ifdef GD_D3D10

#include <Darkstar/Graphic System/Effect/shader_compiler.hpp>
#include <Darkstar/Kernel/logh.hpp>

using namespace gs;
using ker::Log;

bool ShaderCompiler::compileShader(const shared_array<char>& code, const unsigned int size, const shared_array<ShaderMacro>& macros, const std::string& entry_point, const std::string& target)
{
	UINT flags = D3D10_SHADER_PACK_MATRIX_ROW_MAJOR | D3D10_SHADER_AVOID_FLOW_CONTROL;
	ShaderInclude incl;
	ID3D10Blob* errors;
	ID3D10Blob* scode;
	if(FAILED(D3D10CompileShader(code.get(), size, NULL, (D3D10_SHADER_MACRO*)macros.get(), &incl, 
		entry_point.c_str(), target.c_str(), flags, &scode, &errors)))
	{
		lwar << "Cannot compile shader with main function " << entry_point << " and target " << target << " errors: " << static_cast<char*>(errors->GetBufferPointer());
		return false;
	};
	if(errors)
	{
		error_data = (char*)errors->GetBufferPointer();
		error_data_size = (unsigned int)errors->GetBufferSize();
	};

	shader_code = scode->GetBufferPointer();
	shader_code_size = (unsigned int)scode->GetBufferSize();
	return true;
};

#endif