//	Darkstar Engine  (c) UnderWorld Interactive Studio (all coding by Svarog    2007-2008)
//
//          Darkstar Engine.    
//        ,       ( -
//          ).
//
//       : vertex_shader_d3d10.cpp
//       :     DirectX 10
//

#ifdef GD_D3D10

#include <Darkstar/Graphic System/Effect/vertex_shader_d3d10.hpp>
#include <Darkstar/Graphic System/Direct3D/graphicDriver.hpp>
#include <Darkstar/Kernel/logh.hpp>

using gs::VertexShader;
using gs::GraphicDriver;
using ker::Log;

VertexShader::VertexShader()
{
	vs = NULL;
};

VertexShader::~VertexShader()
{
	if(vs)
	{
		vs->Release();
		vs = NULL;
	};
};

bool VertexShader::create(const void* code, const unsigned int code_size)
{
	if(FAILED(GraphicDriver::ptr()->getDevice()->CreateVertexShader(code, code_size, &vs)))
	{
		lwar << "Cannot create vertex shader";
		return false;
	};
	return true;
};

void VertexShader::set()
{
	GraphicDriver::ptr()->getDevice()->VSSetShader(vs);
};

#endif