//	Darkstar Engine  (c) UnderWorld Interactive Studio (all coding by Svarog    2007)
//
//          Darkstar Engine.    
//        ,       ( -
//          ).
//
//       : cull_render_state.cpp
//       : Culling type state block
//

#include <Darkstar/Graphic System/Render State/cull_render_state.hpp>
#include <Darkstar/Graphic System/Render State/render_state_manager.hpp>

using gs::CullModeRenderState;
using gs::DCULL;
using gs::RenderStateManager;

CullModeRenderState::CullModeRenderState()
{
	cull_mode = DCULL_BACK;
};

CullModeRenderState::CullModeRenderState(const CullModeRenderState& cm)
{
	cull_mode = cm.getCullMode();
};

CullModeRenderState::CullModeRenderState(const DCULL& cullMode)
{
	cull_mode = cullMode;
};

CullModeRenderState::~CullModeRenderState()
{

};

bool CullModeRenderState::operator ==(const CullModeRenderState& state) const
{
	return (cull_mode == state.getCullMode());
};

void CullModeRenderState::setCullMode(const DCULL& cullMode)
{
	cull_mode = cullMode;
};

const DCULL& CullModeRenderState::getCullMode() const
{
	return cull_mode;
};

void CullModeRenderState::set()
{
	RenderStateManager::ptr()->setCullModeRenderState(*this);
};