//	Darkstar Engine  (c) UnderWorld Interactive Studio (all coding by Svarog    2007-2008)
//
//          Darkstar Engine.    
//        ,       ( -
//          ).
//
//       : index_buffer_d3d10.hpp
//       :     Direct3D 10
//

#ifdef GD_D3D10

#ifndef DSE_RS_MESH_INDEX_BUFFER_D3D10_HPP
#define DSE_RS_MESH_INDEX_BUFFER_D3D10_HPP

#include <Darkstar/common.hpp>
#include <Darkstar/Graphic System/Direct3D/direct3d_include.hpp>
#include <Darkstar/Resource System/rs_common.hpp>

namespace rs
{
	enum IBTYPE
	{
		DSEIB_16 = 57,
		DSEIB_32 = 42
	};

	class IndexBuffer
	{
	private:
		ID3D10Buffer* buffer;
		IBTYPE buf_type;
		unsigned int buf_size;
		unsigned int ind_count;
	public:
		IndexBuffer();
		IndexBuffer(const unsigned int ind_count, const IBTYPE& type, const DEUSAGE& usage = DEU_DYNAMIC);
		~IndexBuffer();

		bool create(const unsigned int ind_count, const IBTYPE& type, const DEUSAGE& usage = DEU_DYNAMIC);
		bool createWithData(const unsigned int ind_count, const IBTYPE& type, void* data, const DEUSAGE& usage = DEU_DEFAULT);
		bool upload(const unsigned int size, void* data, const unsigned int offset = 0);
		void* map(const DEMAPTYPE& map_type);
		void unmap();

		const unsigned int getIndicesNumber() const;

		void set();
	};
};

#endif

#endif