//	Darkstar Engine  (c) UnderWorld Interactive Studio (all coding by Svarog    2007-2008)
//
//          Darkstar Engine.    
//        ,       ( -
//          ).
//
//       : model_loader.hpp
//       : loader for darkstar models
//

#ifndef DSE_RS_MODEL_MODEL_LOADER_HPP
#define DSE_RS_MODEL_MODEL_LOADER_HPP

#include <Darkstar/common.hpp>
#include <Darkstar/Resource System/Model/static_model.hpp>
#include <Darkstar/Kernel/Misc/singleton.hpp>

namespace rs
{
	class ModelLoader : public ker::SingletonHolder<ModelLoader>
	{
	private:
		stdext::hash_map<std::string, weak_ptr<StaticModel> > cach;
	public:
		ModelLoader();
		~ModelLoader();

		shared_ptr<StaticModel> load(const std::string& filename);
	};
};

#endif